#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <dos.h>

typedef LPSTR FAR PASCAL OVCALLBACK_GET           ( LPSTR );
typedef VOID  FAR PASCAL OVCALLBACK_PUT           ( LPSTR, LPSTR );
typedef LPSTR FAR PASCAL OVCALLBACK_EXECUTESTRING ( LPSTR, LPSTR, unsigned,
    unsigned );
typedef VOID  FAR PASCAL OVCALLBACK_RESET         ( LPSTR );
typedef VOID  FAR PASCAL OVCALLBACK_SETCURRENTROW ( int, int );
typedef int   FAR PASCAL OVCALLBACK_GETCURRENTROW ( int );
typedef int   FAR PASCAL OVCALLBACK_GETLASTROW    ( int );
typedef int   FAR PASCAL OVCALLBACK_ISCOLUMN      ( LPSTR );

struct keyState
{
    int repeatCount : 16;
    int scanCode    : 8;
    int extendedKey : 1;
    int unused      : 4;
    int altShifted  : 1;
    int prevState   : 1;
    int keyUp       : 1;
};

HHOOK KeyboardHook, MouseHook, TimerHook, ClockHook;
HWND MainWindow;
BOOL discardKey;
WPARAM prevMouseMsg;
OVCALLBACK_EXECUTESTRING *lpfnExecute;
OVCALLBACK_PUT *lpfnAssign;
int prevHours, prevMinutes;

#define IDTIMER 101
#define IDCLOCK 102

#define fieldListSize 4096
#define fields 256

char fieldList[fieldListSize];
char *field[fields];
int fieldCount;

char vFieldList[fieldListSize];
char *vField[fields];
int vFieldCount;

char hFieldList[fieldListSize];
char *hField[fields];
int hFieldCount;

/******************************************************************************
*
* name          SelfRegister -- Register all of the functions of this DLL
*
* arguments     1.  OVCALLBACK_EXECUTESTRING lpfnCallBack -- callback fn
*
* return        Zero
*
* register      @REGISTER("@REGISTER_OVEVENTS","In","","ovevents.dll",
*                   "SelfRegister",1)
*
******************************************************************************/

int FAR PASCAL _export SelfRegister(
    OVCALLBACK_EXECUTESTRING lpfnCallBack )
{
    (void)(*lpfnCallBack)(
        "@REGISTER(\"@StartEvents\",\"Iyw\",\"\","
        "\"ovevents.dll\",\"iStartEvents\",1)"
        , 0, 0, 0 );
    (void)(*lpfnCallBack)(
        "@REGISTER(\"@StopEvents\",\"A\",\"\","
        "\"ovevents.dll\",\"iStopEvents\",1)"
        , 0, 0, 0 );
    (void)(*lpfnCallBack)(
        "@REGISTER(\"@StartTimer\",\"AB\",\"Interval\","
        "\"ovevents.dll\",\"iStartTimer\",1)"
        , 0, 0, 0 );
    (void)(*lpfnCallBack)(
        "@REGISTER(\"@StopTimer\",\"A\",\"\","
        "\"ovevents.dll\",\"iStopTimer\",1)"
        , 0, 0, 0 );
    (void)(*lpfnCallBack)(
        "@REGISTER(\"@StartClock\",\"A\",\"\","
        "\"ovevents.dll\",\"iStartClock\",1)"
        , 0, 0, 0 );
    (void)(*lpfnCallBack)(
        "@REGISTER(\"@StopClock\",\"A\",\"\","
        "\"ovevents.dll\",\"iStopClock\",1)"
        , 0, 0, 0 );
    (void)(*lpfnCallBack)(
        "@REGISTER(\"@DiscardKey\",\"A\",\"\","
        "\"ovevents.dll\",\"iDiscardKey\",1)"
        , 0, 0, 0 );
    (void)(*lpfnCallBack)(
        "@REGISTER(\"@SetTabOrder\",\"AC\",\"\"\"Field 1|Field 2|Field N\"\"\","
        "\"ovevents.dll\",\"iSetTabOrder\",1)"
        , 0, 0, 0 );
    (void)(*lpfnCallBack)(
        "@REGISTER(\"@ResetTabOrder\",\"A\",\"\","
        "\"ovevents.dll\",\"iResetTabOrder\",1)"
        , 0, 0, 0 );
    (void)(*lpfnCallBack)(
        "@REGISTER(\"@SetVFieldOrder\",\"AC\",\"\"\"Field 1|Field 2|Field N\"\"\","
        "\"ovevents.dll\",\"iSetVFieldOrder\",1)"
        , 0, 0, 0 );
    (void)(*lpfnCallBack)(
        "@REGISTER(\"@ResetVFieldOrder\",\"A\",\"\","
        "\"ovevents.dll\",\"iResetVFieldOrder\",1)"
        , 0, 0, 0 );
    (void)(*lpfnCallBack)(
        "@REGISTER(\"@SetHFieldOrder\",\"AC\",\"\"\"Field 1|Field 2|Field N\"\"\","
        "\"ovevents.dll\",\"iSetHFieldOrder\",1)"
        , 0, 0, 0 );
    (void)(*lpfnCallBack)(
		"@REGISTER(\"@ResetHFieldOrder\",\"A\",\"\","
        "\"ovevents.dll\",\"iResetHFieldOrder\",1)"
        , 0, 0, 0 );
	(void)(*lpfnCallBack)(
		"@REGISTER(\"@NextTabField\",\"A\",\"\","
		"\"ovevents.dll\",\"iNextTabField\",1)"
		, 0, 0, 0 );
	(void)(*lpfnCallBack)(
		"@REGISTER(\"@PrevTabField\",\"A\",\"\","
		"\"ovevents.dll\",\"iPrevTabField\",1)"
		, 0, 0, 0 );
	(void)(*lpfnCallBack)(
		"@REGISTER(\"@NextHField\",\"A\",\"\","
		"\"ovevents.dll\",\"iNextHField\",1)"
		, 0, 0, 0 );
	(void)(*lpfnCallBack)(
		"@REGISTER(\"@PrevHField\",\"A\",\"\","
		"\"ovevents.dll\",\"iPrevHField\",1)"
		, 0, 0, 0 );
	(void)(*lpfnCallBack)(
		"@REGISTER(\"@NextVField\",\"A\",\"\","
		"\"ovevents.dll\",\"iNextVField\",1)"
		, 0, 0, 0 );
	(void)(*lpfnCallBack)(
		"@REGISTER(\"@PrevVField\",\"A\",\"\","
		"\"ovevents.dll\",\"iPrevVField\",1)"
		, 0, 0, 0 );
	field[0] = NULL;
	*fieldList = 0;
    lpfnExecute = lpfnCallBack;
    return 0;
}

/******************************************************************************
*
* name          MouseProc -- Processes mouse messages
*
* register      This function is not intended to be registered.
*
******************************************************************************/

LRESULT CALLBACK _export MouseProc (int code, WPARAM wParam, LPARAM lParam)
{
    if (wParam == WM_RBUTTONUP ||
        wParam == WM_LBUTTONUP ||
        wParam == WM_RBUTTONDOWN ||
        wParam == WM_LBUTTONDOWN ||
        wParam == WM_LBUTTONDBLCLK ||
        wParam == WM_RBUTTONDBLCLK )
    {
        MOUSEHOOKSTRUCT *clickInfo = (void *)lParam;
        if (clickInfo->hwnd == GetFocus())
        {
            if (GetKeyState(VK_SHIFT) & 0xfe)
                (void)(*lpfnAssign)("Shift Key Down", "Yes");
            else
                (void)(*lpfnAssign)("Shift Key Down", "No");
            if (GetKeyState(VK_CONTROL) & 0xfe)
                (void)(*lpfnAssign)("Control Key Down", "Yes");
            else
                (void)(*lpfnAssign)("Control Key Down", "No");
            if (GetKeyState(0x12) & 0xfe)
                (void)(*lpfnAssign)("Alt Key Down", "Yes");
            else
                (void)(*lpfnAssign)("Alt Key Down", "No");

            switch (wParam)
            {
                case WM_LBUTTONUP:
                    if (prevMouseMsg == WM_LBUTTONDOWN)
                        (void)(*lpfnExecute)("@EVENT(@SELECTEDFIELD,\"Left Click\")",
                            0, 0, 0);
                    break;
                case WM_LBUTTONDBLCLK:
                    (void)(*lpfnExecute)("@EVENT(@SELECTEDFIELD,\"Double Click\")",
                        0, 0, 0);
                    break;
                case WM_RBUTTONUP:
                    if (prevMouseMsg == WM_RBUTTONDOWN)
                        (void)(*lpfnExecute)("@EVENT(@SELECTEDFIELD,\"Right Click\")",
                            0, 0, 0);
                    break;
                case WM_RBUTTONDBLCLK:
                    (void)(*lpfnExecute)("@EVENT(@SELECTEDFIELD,\"Right Double Click\")",
                        0, 0, 0);
                    break;
            }
            prevMouseMsg = wParam;
        }
    }

    return CallNextHookEx(MouseHook, code, wParam, lParam);
}

/******************************************************************************
*
* name          SelectField -- Determine which field to select
*
* register      This function is not intended to be registered.
*
******************************************************************************/

void SelectField (int increment, char *fieldPtr[], int fieldCountPtr)
{
    char currentField[128], selectedField[128], command[140];
    int i, fieldIndex = -1;
    char *source, *dest;

    (void)(*lpfnExecute)("@SELECTEDFIELD", (LPSTR)selectedField,
        sizeof(selectedField), 0);

//	MessageBox (0, selectedField, "Selected Field", 0);
    source = selectedField;
    dest = currentField;
    if (strcspn(selectedField, "!\"#$%&'()*+,-./:;<=>?@[\\]^{}~`") < strlen(source))
    {
        for (*(dest++) = '\''; *source != NULL; source++, dest++)
        {
            if (*source == '\'')
            {
                *dest++ = *source;
                *dest = *source;
            }
            else
                *dest = *source;
        }
        *dest = *source;
        strcat(dest, "'");
    }
    else
        strcpy(dest, source);

	for (i = 0; fieldPtr[i] != NULL; i++)
    {
        if (stricmp(fieldPtr[i], currentField) == 0)
        {
            fieldIndex = i;
            break;
        }
    }
	if (fieldIndex == -1)
    {
        return;
	}

    fieldIndex += increment;

    if (fieldIndex < 0)
        fieldIndex = fieldCountPtr;
    if (fieldIndex > fieldCountPtr)
        fieldIndex = 0;

//	MessageBox(NULL, fieldPtr[fieldIndex], "New Field", 0);
    sprintf(command, "@FIELDFIND(%s)", fieldPtr[fieldIndex]);
    (void)(*lpfnExecute)(command, 0, 0, 0);
    discardKey = TRUE;
}

/******************************************************************************
*
* name          KeyboardProc -- Processes keyboard messages
*
* register      This function is not intended to be registered.
*
******************************************************************************/

LRESULT CALLBACK _export KeyboardProc (int code, WPARAM wParam, LPARAM lParam)
{
    struct keyState state;
    char keyName[64], fullKeyName[64], command[128];

    state = *(struct keyState*)&lParam;
    if (!state.keyUp && // Key pressed, not released
        wParam != VK_SHIFT && 
        wParam != VK_CONTROL && 
        wParam != 0x12 ) // Alt key
    {
        BOOL shiftKeyDown, controlKeyDown, altKeyDown;
        char className[64];

        GetClassName(GetActiveWindow(), className, sizeof(className));
		if (stricmp(className, "ObjectVisionClass") != 0 &&
			stricmp(className, "ObjectVisionClassR") != 0 )
            return CallNextHookEx(KeyboardHook, code, wParam, lParam);

        GetClassName(GetFocus(), className, sizeof(className));
//		MessageBox(0, className, "Class Name", 0);
		if (stricmp(className, "Button") != 0 &&
            stricmp(className, "Edit") != 0 &&
			stricmp(className, "ListBox") != 0 &&
			stricmp(className, "ObjectVisionNullClass") != 0 &&
			stricmp(className, "ObjectVisionNullClassR") != 0)
			return CallNextHookEx(KeyboardHook, code, wParam, lParam);

        *fullKeyName = '\0';
        GetKeyNameText(lParam, (LPSTR)&keyName, 63);

        shiftKeyDown = GetKeyState(VK_SHIFT) & 0xfe;
        controlKeyDown = GetKeyState(VK_CONTROL) & 0xfe;
        altKeyDown = GetKeyState(0x12) & 0xfe;

        if (shiftKeyDown)
        {
            (void)(*lpfnAssign)("Shift Key Down", "Yes");
            strcat (fullKeyName, "Shift ");
        }
        else
            (void)(*lpfnAssign)("Shift Key Down", "No");

        if (controlKeyDown)
        {
            (void)(*lpfnAssign)("Control Key Down", "Yes");
            strcat (fullKeyName, "Control ");
        }
        else
            (void)(*lpfnAssign)("Control Key Down", "No");

        if (altKeyDown)
        {
            (void)(*lpfnAssign)("Alt Key Down", "Yes");
            strcat (fullKeyName, "Alt ");
        }
        else
            (void)(*lpfnAssign)("Alt Key Down", "No");

        if (shiftKeyDown == FALSE &&
            controlKeyDown == FALSE &&
            altKeyDown == FALSE)
            strcat (fullKeyName, "Unshifted ");

        strcat (fullKeyName, keyName);

		(void)(*lpfnAssign)("Last Key Pressed", keyName);

		discardKey = FALSE;

        if (fieldCount > 0)
        {
            if (stricmp(fullKeyName, "Unshifted Tab") == 0)
                SelectField(1, field, fieldCount);
			else if (stricmp(fullKeyName, "Unshifted Enter") == 0)
            {
                if (stricmp(className, "Button") != 0)
                    SelectField(1, field, fieldCount);
            }
            else if (stricmp(fullKeyName, "Shift Tab") == 0)
                SelectField(-1, field, fieldCount);
        }

        if (vFieldCount > 0)
        {
            if (stricmp(fullKeyName, "Unshifted Down") == 0)
                SelectField(1, vField, vFieldCount);
            else if (stricmp(fullKeyName, "Unshifted Up") == 0)
                SelectField(-1, vField, vFieldCount);
        }

        if (hFieldCount > 0)
        {
            if (stricmp(className, "Edit") != 0)
                if (stricmp(fullKeyName, "Unshifted Right") == 0)
                    SelectField(1, hField, hFieldCount);
                else if (stricmp(fullKeyName, "Unshifted Left") == 0)
                    SelectField(-1, hField, hFieldCount);
        }

		if (stricmp(fullKeyName, "Unshifted Enter") == 0)
			if (stricmp(className, "Button") == 0)
            {
                (void)(*lpfnExecute)("@EVENT(@SELECTEDFIELD,\"Click\")",
					0, 0, 0);
                discardKey = TRUE;
            }

        if ((strlen(keyName) == 1 ||
             strcmp(keyName, "Space") == 0) && 
             !(GetKeyState(VK_CONTROL) & 0xfe ||
             GetKeyState(0x12) & 0xfe))
        {
            sprintf(command, "@EVENT(@SELECTEDFIELD,\"%s\")", keyName);
            (void)(*lpfnExecute)(command, 0, 0, 0);
            sprintf(command, "@EVENT(@SELECTEDFIELD,\"%s\")", fullKeyName);
            (void)(*lpfnExecute)(command, 0, 0, 0);
            sprintf(command, "@EVENT(@SELECTEDFIELD,\"Key Pressed\")");
            (void)(*lpfnExecute)(command, 0, 0, 0);
        }
        else
        {
            sprintf(command, "@EVENT(@SELECTEDFORM,\"%s\")", keyName);
            (void)(*lpfnExecute)(command, 0, 0, 0);
            sprintf(command, "@EVENT(@SELECTEDFORM,\"%s\")", fullKeyName);
            (void)(*lpfnExecute)(command, 0, 0, 0);
            sprintf(command, "@EVENT(\"\",\"%s\")", keyName);
            (void)(*lpfnExecute)(command, 0, 0, 0);
            sprintf(command, "@EVENT(\"\",\"%s\")", fullKeyName);
            (void)(*lpfnExecute)(command, 0, 0, 0);
        }
    }

    if (discardKey)
        return 1;  // discard message
    else
        return CallNextHookEx(KeyboardHook, code, wParam, lParam);
}

/******************************************************************************
*
* name          TimerProc -- Processes timer event messages
*
* register      This function is not intended to be registered.
*
******************************************************************************/

#pragma argsused
void CALLBACK _export TimerProc(HWND hwnd, UINT msg, UINT idTimer, DWORD dwTime)
{
    (void)(*lpfnExecute)("@EVENT(\"\",\"Timer Tick\")", 0, 0, 0);
}

/******************************************************************************
*
* name          ClockProc -- Processes clock event messages
*
* register      This function is not intended to be registered.
*
******************************************************************************/

#pragma argsused
void CALLBACK _export ClockProc(HWND hwnd, UINT msg, UINT idTimer, DWORD dwTime)
{
    int hours, minutes, seconds;
    char buf[20];

    (void)(*lpfnExecute)("@EVENT(\"\",\"Clock Tick\")", 0, 0, 0);
    (void)(*lpfnExecute)("@ASSIGN(\"System Time\",@NOW)", 0, 0, 0);

    // Get current system time using DOS interrupt 21h function 2Ch
    _AH = 0x2C;
    geninterrupt(0x21);
    hours = _CH;
    minutes = _CL;
    seconds = _DH;

    itoa(seconds, buf, 10); 
    (void)(*lpfnAssign)("Seconds", buf);

    if (prevMinutes != minutes)
    {
        itoa(minutes, buf, 10);
        (void)(*lpfnAssign)("Minutes", buf);
        (void)(*lpfnExecute)("@EVENT(\"\",\"Minute Change\")", 0, 0, 0);
        prevMinutes = minutes;
    }

    if (prevHours != hours)
    {
        itoa(hours, buf, 10);
        (void)(*lpfnAssign)("Hours", buf);
        (void)(*lpfnExecute)("@EVENT(\"\",\"Hour Change\")", 0, 0, 0);
        if (hours == 0)
            (void)(*lpfnExecute)("@EVENT(\"\",\"Date Change\")", 0, 0, 0);
        prevHours = hours;
    }
}

/******************************************************************************
*
* name          iStartEvents -- Sets up extra event routines
*
* description   Use this function to add extra events to your fields
*
* arguments     1.  HINST -- Instance handle of main window  
*
* return        Zero (an int)
*
* register      @REGISTER("@StartEvents","Iyw","",
*                   "function.dll","iStartEvents",1)
*
******************************************************************************/

int FAR PASCAL _export iStartEvents(
    HWND HWindow,
    OVCALLBACK_PUT lpfnPut )
{
    HOOKPROC pKeyboardProc, pMouseProc;
    HANDLE moduleHandle;
    char message[100];

    lpfnAssign = lpfnPut;
    MainWindow = HWindow;
    moduleHandle = GetModuleHandle("OVEVENTS.DLL");

    if (KeyboardHook == 0)
    {
        pKeyboardProc = GetProcAddress(moduleHandle, "KeyboardProc");
        KeyboardHook = SetWindowsHookEx(WH_KEYBOARD, pKeyboardProc,
            moduleHandle, GetWindowTask(HWindow));
    }

    if (MouseHook == 0)
    {
        pMouseProc = GetProcAddress(moduleHandle, "MouseProc");
        MouseHook = SetWindowsHookEx(WH_MOUSE, pMouseProc,
            moduleHandle, GetWindowTask(HWindow));
    }

    return 0;
}

/******************************************************************************
*
* name          iStopEvents -- Stops event processing and cleans up
*
* description   Use this function at the end of the program
*
* arguments     none  
*
* return        none
*
* register      @REGISTER("@StopEvents","A","",
*                   "ovevents.dll","iStopEvents",1)
*
******************************************************************************/

int FAR PASCAL _export iStopEvents()
{
    if (KeyboardHook != NULL)
        UnhookWindowsHookEx(KeyboardHook);
    if (MouseHook != NULL)
        UnhookWindowsHookEx(MouseHook);
    if (TimerHook != NULL)
        KillTimer(TimerHook, IDTIMER);
    if (ClockHook != NULL)
        KillTimer(ClockHook, IDCLOCK);

    return 0;
}

/******************************************************************************
*
* name          iStartTimer -- Sets up a timer event routines
*
* description   Use this function to add a timer events to the application
*
* arguments     1.  int -- Interval in seconds between ticks  
*
* return        Zero (an int)
*
* register      @REGISTER("@StartTimer","IB","Interval",
*                   "function.dll","iStartTimer",1)
*
******************************************************************************/

int FAR PASCAL _export iStartTimer(
    double interval )
{
    HOOKPROC pTimerProc;
    HANDLE moduleHandle;

    moduleHandle = GetModuleHandle("OVEVENTS.DLL");

    if (TimerHook == 0)
    {
        pTimerProc = GetProcAddress(moduleHandle, "TimerProc");
        TimerHook = SetTimer(NULL, IDTIMER, (long)(1000. * interval), pTimerProc);
    }

    return 0;
}

/******************************************************************************
*
* name          iStopTimer -- Stops timer event processing 
*
* description   Use this function to stop timer events
*
* arguments     none  
*
* return        none
*
* register      @REGISTER("@StopTimer","A","",
*                   "ovevents.dll","iStopTimer",1)
*
******************************************************************************/

int FAR PASCAL _export iStopTimer()
{
    if (TimerHook != NULL)
        KillTimer(TimerHook, IDTIMER);
    return 0;
}

/******************************************************************************
*
* name          iStartClock -- Sets up the clock event routines
*
* description   Use this function to add a clock events to the application
*
* arguments     none  
*
* return        Zero (an int)
*
* register      @REGISTER("@StartClock","I","",
*                   "function.dll","iStartClock",1)
*
******************************************************************************/

int FAR PASCAL _export iStartClock()
{
    HOOKPROC pClockProc;
    HANDLE moduleHandle;

    moduleHandle = GetModuleHandle("OVEVENTS.DLL");

    if (ClockHook == 0)
    {
        pClockProc = GetProcAddress(moduleHandle, "ClockProc");
        ClockHook = SetTimer(NULL, IDCLOCK, 1000, pClockProc);
    }

    // guarantees a change when the first tick occurs
    prevHours = -1;
    prevMinutes = -1;

    return 0;
}

/******************************************************************************
*
* name          iStopClock -- Stops clock event processing 
*
* description   Use this function to stop clock events
*
* arguments     none  
*
* return        none
*
* register      @REGISTER("@StopClock","A","",
*                   "ovevents.dll","iStopClock",1)
*
******************************************************************************/

int FAR PASCAL _export iStopClock()
{
    if (ClockHook != NULL)
        KillTimer(ClockHook, IDCLOCK);
    return 0;
}

/******************************************************************************
*
* name          iDiscardKey -- Keeps Windows from processing a trapped keystroke
*
* description   Use this function inside a keystroke-generated event to keep
*               Windows from performing normal processing with the keystroke.
*               You may still do your own processing with the event.
*
* arguments     none  
*
* return        none
*
* register      @REGISTER("@DiscardKey","A","",
*                   "ovevents.dll","iDiscardKey",1)
*
******************************************************************************/

int FAR PASCAL _export iDiscardKey()
{
    discardKey = TRUE;
    return 0;
}

/******************************************************************************
*
* name          iSetTabOrder -- Sets the tab order for a form
*
* description   Use this function to override the default ObjectVision field
*               tab order
*
* arguments     LPSTR -- field list delimited by |  
*
* return        none
*
* register      @REGISTER("@SetTabOrder","AC","Field 1|Field 2|Field N",
*                   "ovevents.dll","iSetTabOrder",1)
*
******************************************************************************/

int FAR PASCAL _export iSetTabOrder(
    LPSTR fieldOrder )
{
    int fieldCounter = 0;
    char *p, *start, *endloop;
    char command[140];
          
    strcpy (fieldList, fieldOrder);

    endloop = fieldList + strlen(fieldList);
    start = fieldList;
    for (p = fieldList; p < endloop; p++)
    {
        if (*p == '|')
        {
            *p = 0;
            field[fieldCounter++] = start;
            start = p + 1;
        }           
    }
    fieldCount = fieldCounter;
    field[fieldCounter++] = start;
    field[fieldCounter] = 0;

    return 0;
}

/******************************************************************************
*
* name          iResetTabOrder -- Resets the tab order for a form
*
* description   Use this function to reset the tab order to the normal
*               ObjectVision default
*
* arguments     none  
*
* return        none
*
* register      @REGISTER("@ResetTabOrder","A","",
*                   "ovevents.dll","iResetTabOrder",1)
*
******************************************************************************/

int FAR PASCAL _export iResetTabOrder()
{
    fieldList[0] = NULL;
    fieldCount = 0;
    return 0;
}

/******************************************************************************
*
* name          iSetVFieldOrder -- Sets the vertical arrow keys order for a form
*
* description   Use this function to override the default ObjectVision field
*               order for the vertical arrow keys
*
* arguments     LPSTR -- field list delimited by |  
*
* return        none
*
* register      @REGISTER("@SetVFieldOrder","AC","Field 1|Field 2|Field N",
*                   "ovevents.dll","iSetVFieldOrder",1)
*
******************************************************************************/

int FAR PASCAL _export iSetVFieldOrder(
    LPSTR fieldOrder )
{
    int fieldCounter = 0;
    char *p, *start, *endloop;
    char command[140];
          
    strcpy (vFieldList, fieldOrder);

    endloop = vFieldList + strlen(vFieldList);
    start = vFieldList;
    for (p = vFieldList; p < endloop; p++)
    {
        if (*p == '|')
        {
            *p = 0;
            vField[fieldCounter++] = start;
            start = p + 1;
        }           
    }
    vFieldCount = fieldCounter;
    vField[fieldCounter++] = start;
    vField[fieldCounter] = 0;

    return 0;
}

/******************************************************************************
*
* name          iResetVFieldOrder -- Resets the vertical keys order for a form
*
* description   Use this function to reset the vertical field order set by
*               @SetVFieldOrder.
*
* arguments     none  
*
* return        none
*
* register      @REGISTER("@ResetVFieldOrder","A","",
*                   "ovevents.dll","iResetVFieldOrder",1)
*
******************************************************************************/

int FAR PASCAL _export iResetVFieldOrder()
{
    vFieldList[0] = NULL;
    vFieldCount = 0;
    return 0;
}

/******************************************************************************
*
* name          iSetHFieldOrder -- Sets the vertical arrow keys order for a form
*
* description   Use this function to override the default ObjectVision field
*               order for the vertical arrow keys
*
* arguments     LPSTR -- field list delimited by |  
*
* return        none
*
* register      @REGISTER("@SetHFieldOrder","AC","Field 1|Field 2|Field N",
*                   "ovevents.dll","iSetHFieldOrder",1)
*
******************************************************************************/

int FAR PASCAL _export iSetHFieldOrder(
    LPSTR fieldOrder )
{
    int fieldCounter = 0;
    char *p, *start, *endloop;
    char command[140];
          
    strcpy (hFieldList, fieldOrder);

    endloop = hFieldList + strlen(hFieldList);
    start = hFieldList;
    for (p = hFieldList; p < endloop; p++)
    {
        if (*p == '|')
        {
            *p = 0;
            hField[fieldCounter++] = start;
            start = p + 1;
        }           
    }
    hFieldCount = fieldCounter;
    hField[fieldCounter++] = start;
    hField[fieldCounter] = 0;

    return 0;
}

/******************************************************************************
*
* name          iResetHFieldOrder -- Resets the vertical keys order for a form
*
* description   Use this function to reset the vertical field order set by
*               @SetHFieldOrder.
*
* arguments     none  
*
* return        none
*
* register      @REGISTER("@ResetHFieldOrder","A","",
*                   "ovevents.dll","iResetHFieldOrder",1)
*
******************************************************************************/

int FAR PASCAL _export iResetHFieldOrder()
{
    hFieldList[0] = NULL;
    hFieldCount = 0;
    return 0;
}

/******************************************************************************
*
* name          iNextTabField -- Selects the next field in the current tab order
*
* description   Use this function to emulate the pressing of the Tab key
*
* arguments     none  
*
* return        none
*
* register      @REGISTER("@NextTabField","A","",
*                   "ovevents.dll","iNextTabField",1)
*
******************************************************************************/

int FAR PASCAL _export iNextTabField()
{
	SelectField(1, field, fieldCount);
	return 0;
}

/******************************************************************************
*
* name          iPrevTabField -- Selects the previous field in the current tab
*				order
*
* description   Use this function to emulate the pressing of the Backtab key
*				(Shift Tab).
*
* arguments     none  
*
* return        none
*
* register      @REGISTER("@PrevTabField","A","",
*                   "ovevents.dll","iPrevTabField",1)
*
******************************************************************************/

int FAR PASCAL _export iPrevTabField()
{
	SelectField(-1, field, fieldCount);
	return 0;
}

/******************************************************************************
*
* name          iNextHField -- Selects the next field in the current horizontal
*				field order
*
* description   Use this function to emulate the pressing of the Right arrow key
*
* arguments     none  
*
* return        none
*
* register      @REGISTER("@NextHField","A","",
*                   "ovevents.dll","iNextHField",1)
*
******************************************************************************/

int FAR PASCAL _export iNextHField()
{
	SelectField(1, hField, hFieldCount);
	return 0;
}

/******************************************************************************
*
* name          iPrevHField -- Selects the previous field in the current horizontal
*				field order
*
* description   Use this function to emulate the pressing of the Left arrow key.
*
* arguments     none  
*
* return        none
*
* register      @REGISTER("@PrevHField","A","",
*                   "ovevents.dll","iPrevHField",1)
*
******************************************************************************/

int FAR PASCAL _export iPrevHField()
{
	SelectField(-1, hField, hFieldCount);
	return 0;
}

/******************************************************************************
*
* name          iNextVField -- Selects the next field in the current vertical
*				field order
*
* description   Use this function to emulate the pressing of the Down arrow key
*
* arguments     none  
*
* return        none
*
* register      @REGISTER("@NextVField","A","",
*                   "ovevents.dll","iNextVField",1)
*
******************************************************************************/

int FAR PASCAL _export iNextVField()
{
	SelectField(1, vField, vFieldCount);
	return 0;
}

/******************************************************************************
*
* name          iPrevVField -- Selects the previous field in the current vertical
*				field order
*
* description   Use this function to emulate the pressing of the Up arrow key.
*
* arguments     none  
*
* return        none
*
* register      @REGISTER("@PrevVField","A","",
*                   "ovevents.dll","iPrevVField",1)
*
******************************************************************************/

int FAR PASCAL _export iPrevVField()
{
	SelectField(-1, vField, vFieldCount);
	return 0;
}

#pragma argsused
int FAR PASCAL LibMain( HANDLE hInstance, WORD wDataSegment,
                        WORD wHeapSize, LPSTR lpszCmdLine )
{
    if ( wHeapSize != 0 )
        UnlockData( 0 );
    KeyboardHook = 0;
    MouseHook = 0;
    return 1; 
}

#pragma argsused
int FAR PASCAL WEP ( int bSystemExit )
{
    return 1;
}
